Bug 414031 - (CVE-2007-5760) CVE-2007-5760 xorg: invalid array indexing in XFree86-Misc extension
CVE-2007-5760 xorg: invalid array indexing in XFree86-Misc extension
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
source=vendorsec,reported=20071204,pu...
: Security
Depends On: 419481 419501 419521 419531 429125 429126 429127
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-06 09:59 EST by Tomas Hoger
Modified: 2008-01-31 18:26 EST (History)
7 users (show)

See Also:
Fixed In Version: 1.3.0.0-39.fc8
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-22 10:31:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Tomas Hoger 2007-12-06 09:59:15 EST
iDefense reported a vulnerability discovered by regenrecht affecting Xorg X server:

DESCRIPTION

Local exploitation of an invalid array index vulnerability in the X.Org
X server, as included in various vendors' operating system
distributions, could allow an attacker to execute arbitrary code with
the privileges of the X server, typically root.

The vulnerability exists within the code responsible for processing
PassMessage requests. The handler for this request takes a 32-bit value
from the client's request, and uses it as an index into an array of
structures. The structure obtained contains an array of function
pointers, and one of them is dereferenced later in the request. By
supplying a large array index, an arbitrary function pointer can be
dereferenced.

The vulnerable code is shown below:

From hw/xfree86/dixmods/extmod/xf86misc.c:ProcXF86MiscPassMessage()

596  if ((retval =
MiscExtPassMessage(stuff->screen,msgtype,msgval,&retstr)) != 0) {

597   xfree(msgtype);

598   xfree(msgval);

599   return retval;

699  }

From hw/xfree86/common/xf86MiscExt.c:MiscExtPassMessage()

567  ScrnInfoPtr pScr = xf86Screens[scrnIndex];

568

569  DEBUG_P("MiscExtPassMessage");

570

571  if (*pScr->HandleMessage == NULL)

572   return BadImplementation;

573  return (*pScr->HandleMessage)(scrnIndex, msgtype, msgval, retstr);

On line 596, the stuff->screen value is passed to the
MiscExtPassMessage() function. On line 567, this value is then used as
an index into the xf86Screens array. On line 573, a function pointer
from this structure is then dereferenced. At no time is the
stuff->screen parameter validated.

ANALYSIS

Exploitation allows an attacker to execute arbitrary code with root
privileges. In order to exploit this vulnerability, an attacker must be
able to send commands to an affected X server. This typically requires
access to the console or access to the same account as a user who is on
the console. One method of gaining the required access is to remotely
exploit a vulnerability in, for example, a graphical web browser. This
would then allow an attacker to exploit this vulnerability and elevate
their privileges to root.

If an X Server is configured to listen for TCP based client connections,
and a client is granted access to create sessions (via the xhosts file),
then the vulnerability can be exploited remotely.

WORKAROUND

If the XC-MISC extension has not been built-in to the server, then it
can be prevented from loading by inserting the following into the X
configuration file (usually in /etc/X11/xorg.conf):

Section "Module"

        SubSection "extmod"

                Option "omit XC-MISC"

                Option "omit XFree86-Misc"

        EndSubSection

EndSection

To check if the extension is built-in to the server, grep the output of
the X Server log file:

grep built-in /var/log/Xorg.0.log

The result will list all built in extensions. The location of the log
file may need to be changed.
Comment 1 Tomas Hoger 2007-12-06 10:01:58 EST
Upstream bug report:

  https://bugs.freedesktop.org/show_bug.cgi?id=13524
Comment 9 Tomas Hoger 2008-01-02 02:36:31 EST
According to upstream, this issue only affects XFree86-MISC extension, XC-MISC
is not affected.  Upstream does not recommend disabling XC-MISC as suggested in
iDefense advisory in Workaround section.
Comment 12 Yan Tian 2008-01-15 04:21:35 EST
Verified patch 'freedesktop-bug-13524.patch' was excluded from
xorg-x11-6.8.2-1.EL.33.0.1.src.rpm. And the patch 'cve-2007-5760.patch' fixed
xf86MiscExt.c file.
Comment 14 Josh Bressers 2008-01-17 09:51:19 EST
Lifting embargo:
http://lists.freedesktop.org/archives/xorg/2008-January/031918.html
Comment 16 Fedora Update System 2008-01-22 10:31:42 EST
xorg-x11-server-1.3.0.0-39.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2008-01-22 10:49:14 EST
xorg-x11-server-1.3.0.0-15.fc7 has been pushed to the Fedora 7 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.